<template>
  <component
    v-wave
    :is="to ? 'nuxt-link' : 'button'"
    :to="to"
    class="btn"
    @click="handleClick"
    :class="{
      'btn--disabled': disabled,
      [`btn--variant-${variant}`]: variant,
      [`btn--size-${size}`]: size,
      [`btn--border-${border}`]: border,
      [`btn--radius-${radius}`]: radius
    }"
  >
    <slot />
  </component>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import type { UiVariant, UiSize } from '@/types/ui'

export default defineComponent<{
  to: string
  variant: UiVariant
  size: UiSize
  border: UiVariant
  radius: UiVariant
  disabled: boolean
}>({
  name: 'Button',
  props: ['to', 'variant', 'size', 'radius', 'border', 'disabled'],
  setup(_, { emit }) {
    const handleClick = (event: any) => {
      emit('click', event)
    }
    return {
      handleClick
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';

a.btn,
.btn {
  display: flex;
  background: var(--color-primary);
  padding: 18px 25px;
  text-align: center;
  color: var(--color-light);
  text-decoration: none;
  font-size: 20px;
  line-height: 24px;
  border: none;
  outline: none;
  cursor: pointer;
  width: 100%;
  min-height: 100%;
  align-items: center;
  justify-content: center;
  border-radius: 10px;
  transition: 0.25s all linear;

  @media (min-width: 1199.98px) {
    font-size: 24px;
    line-height: 28px;
    padding: 20px 50px 22px 50px;
  }

  ::v-deep svg {
    fill: #fff;
    width: 20px;
    height: 20px;
    margin-left: 15px;
    &.icon-radius {
      border: 2px solid rgba(#ffffff, 0.5);
      border-radius: 50px;
      padding: 8px;
      width: 32px;
      height: 32px;
    }
    &.icon-primary {
      background: var(--color-primary);
      border: 2px solid var(--color-primary);
    }
  }

  &[icon] {
    padding: 12px 25px;
    ::v-deep svg {
      margin: 0px;
      width: 25px;
      height: 25px;
      fill: #fff;
    }
  }

  &-space {
    justify-content: space-between;
  }

  &--disabled {
    pointer-events: none;
    opacity: 0.5;
  }

  &--variant {
    &-dark {
      color: var(--color-light);
      background: var(--color-dark-1);
    }

    &-bg {
      color: var(--color-light);
      background: var(--color-bg);
    }

    &-success {
      color: var(--color-dark-3);
      background: var(--color-success);
      &-opacity {
        background: rgba($--color-success, 0.2);
      }
      ::v-deep svg {
        fill: #00ffb3;
        &.icon-radius {
          border: 2px solid rgba(#00ffb3, 0.5);
        }
      }
    }

    &-light {
      color: var(--color-dark-4);
      background: var(--color-light);
    }

    &-danger {
      color: var(--color-light);
      background: var(--color-danger);
      &-opacity {
        color: var(--color-danger);
        background: rgba($--color-danger, 0.3);
      }
    }
    &-none {
      color: var(--color-light);
      font-weight: 500;
      background: 0;
      ::v-deep svg {
        fill: var(--color-primary);
        &.icon-radius {
          border: 2px solid rgba(#0065ff, 0.5);
        }
      }
      &:hover {
        background: var(--color-primary);
        ::v-deep svg {
          fill: var(--color-light);
          &.icon-radius {
            border: 2px solid rgba(#fff, 0.5);
          }
        }
      }
    }

    &-white-opacity {
      color: var(--color-light);
      background: rgba(#ffffff, 0.3);
    }
    &-grey {
      color: #9badd6;
      background: #373e57;
    }
  }

  &--border {
    &-primary {
      border: 2px solid var(--color-primary);
    }
    &-secondary {
      border: 2px solid var(--color-primary);
    }
    &-grey {
      border: 2px solid #3b435a;
      &:hover {
        border-color: rgba(#3b435a, 0);
      }
    }
  }

  &--size {
    &-inline {
      display: inline-flex;
      width: auto;
    }

    &-small {
      padding: 18px 25px;
    }

    &-medium {
      padding: 20px 30px 21px 30px;
    }
  }

  &--radius {
    &-larger {
      border-radius: 80px;
    }
  }

  &.auth__google {
    padding-left: 30px;
    padding-right: 30px;
    border-radius: 80px;
    ::v-deep svg {
      width: 32px;
      height: 32px;
      margin-right: 20px;
      margin-left: 0px;
    }
  }
}
</style>
